

#include "pattern.h"


const int buttonPin=12;

/* 
 * This is the fix to signal to external circuitry that the input (buttonPin)
 * is being read
 */
const int readSignal=11;


const int dots[] = { 2,3,4,5,6,7,8 };
  
void setup()
{
  int i;
  
  pinMode(buttonPin, INPUT);

  pinMode(readSignal, OUTPUT);

  for (i=0;i<7;i++)
    {
      pinMode(dots[i], OUTPUT);
    }

}



void loop()
{
  /** Main loop runs at ~1000 Hz when button pressed
   * Button is only checked at ~10 Hz, since we want a low amount
   *  of debug data for this example
   */

  int timer=0;

  int ledState = 0;

  int buttonState = 0;
  
  while(1)
    {
      delay(1);

      /* This may be set low inside code below, here we set it back
	 to high all times, TODO: a state machine might be nicer for this
      */
      digitalWrite(readSignal, HIGH);
      
      timer++;

      /* Advance pattern on leds... */
      if (buttonState == 0)
	{
	  if (ledState >= 6)
	    {
	      ledState = 0;
	    }

	  /* Output to leds */
	  int j;
	  for (j=0;j<=6;j++)
	    {
	      digitalWrite(dots[j], pattern[ledState][j+1]);
	    }

          ledState++;
	}
      else
        {
	  /* Output to leds (fixed pattern when button released) */
	  int j;
	  for (j=0;j<=6;j++)
	    {
	      digitalWrite(dots[j], pattern[ledState][j+1]);
	    }
          
        }
   
      // 97 is about right for 100ms, Ben tried to time this with
      // a stop watch but we don't really know if he succeeded.
      if (timer==97)
	{
	  /** Trigger the flipflop to sample present value of button */
	  digitalWrite(readSignal, LOW);
	  
	  /* Now it is time to read the button's sampled value
	     in sync with the external circuitry 
	     TODO: we might want a delay before reading here
	     (state machine)
	  */
	  buttonState = digitalRead(buttonPin);
	  timer=0;
	}
    }
}
