
const int INPUT=0;
const int OUTPUT=1;

const int LOW=0;
const int HIGH=1;

void pinMode(int pin, int mode);
int digitalRead(int pin);
int digitalWrite(int pin, int value);
int delay(int ms);

/** TODO: Make this name selectable, macro? */
#include "dice/dice.ino"

/** Variables and functions defined here will not be
    visible to ino file
*/
#include <stdio.h>
#include <stdlib.h>

static FILE* invaluefile;

/* Special for dice, store all led values, then output on 10 below */
int store[7];

/** argc argv solely used for simulator use, not applicable to embedded */
int main(int argc, char* argv[])
{
  int i;

  for (i=0;i<7;i++) store[i]=0;
  
  if (argc!=2)
    {
      fprintf(stderr, "Usage: %s <input value file>\n", argv[0]);
      exit(1);
    }

  invaluefile = fopen(argv[1], "r");
  if (NULL == invaluefile)
    {
      fprintf(stderr, "File: %s could not be opened\n", argv[1]);
      exit(1);
    }
  
  setup();
  while (1) loop();
}

void pinMode(int pin, int mode)
{
  /** Does nothing*/
}

int digitalRead(int pin)
{
  int retval;
  if (feof(invaluefile))
    {
      printf("Encountered eof\n");
      exit(0);
    }
  fscanf(invaluefile, "%d", &retval);

  printf("invalue: %d\n", retval);
  
  return retval;
}



void dumpdice()
{
  printf("| %c %c %c |\n",
	 store[0]?' ':'X',
	 store[1]?' ':'X',
	 store[2]?' ':'X');
  printf("|   %c   |\n",
	 store[3]?' ':'X');
  printf("| %c %c %c |\n",
	 store[4]?' ':'X',
	 store[5]?' ':'X',
	 store[6]?' ':'X');
}

int digitalWrite(int pin, int value)
{

  if (pin>=2 && pin<=8) store[pin-2]=value;
}

int delayacc = 0;

int delay(int ms)
{
  delayacc += ms;
  
  /** We do "nothing" here simulation-wise since timing issues should be
      eliminated from simulation round and we want things to go as fast as
      possible
  */

  // When the delay comes we print the outputs. There are glitches
  // when we move pattern since each eye of the dice is set individually.
  // These glitches are not shown currently.
  printf("Time: %d\n", delayacc);
  printf("---------\n");
  dumpdice();
  printf("---------\n");

}
