
#include <wiringPi.h>

#include <stdio.h>
#include <unistd.h>


int main()
{
  int reset, ck, q;

  const int resetpin=8;
  const int ckpin=9;
  const int qpin=7;

  wiringPiSetup();
  
  pinMode(resetpin, INPUT);
  pinMode(ckpin, INPUT);
  pinMode(qpin, INPUT);
  
  q=digitalRead(qpin);

  while(1)
    {
      // Wait for first reset..
      reset=digitalRead(resetpin);
      if (reset == 0) break;
    }

  while(1)
    {
      // Wait for reset release..
      reset=digitalRead(resetpin);
      if (reset == 1) break;
    }

  printf("Reset received...\n");

  FILE* log;
  log=fopen("in.txt", "w");

  // State machine should make it so that only one d is read per clock tick
  int state = 0;
  
  while (1)
    {
      // Has second reset occured? then we terminate
      reset=digitalRead(resetpin);
      if (reset == 0)
	{
	  fclose(log);
	  return 0;
	}

      // Do we have a clock? if so store the data 
      ck=digitalRead(ckpin);
      if (ck==0 && state == 0)
	{
	  state=1;
	}
      if (ck == 1 && state == 1)
	{
	  q=digitalRead(qpin);
	  fprintf(log, "%c\n", q+'0');
	  state = 0;
	}
      
    }
}

